
# Set up the default dialogs

import FileDialog, MultiFileDialog

OpenFile = FileDialog.LoadFileDialog
OpenMultipleFiles = MultiFileDialog.LoadFilesDialog
SaveFile = FileDialog.SaveFileDialog

# Now see if we can use Mitch's Dialogs


try:
    from TkDlgWrapper import OpenSaveFile

except:
    pass

else:
    import os

    class OpenWrapper(OpenSaveFile):
	def __init__(self, master=None, **kw):
	    apply(OpenSaveFile.__init__, 
		  (self, "tk_getOpenFile", master), kw)

	def go(self, dir_or_file=os.curdir, pattern="*", default="", key=None):
	    return self.show(initialdir=dir_or_file,
			     defaultextension=pattern,
			     filetypes=((pattern,pattern),
					('Any File','*')),
			     initialfile=default)

    class SaveWrapper(OpenSaveFile):
	def __init__(self, master=None, **kw):
	    apply(OpenSaveFile.__init__, 
		  (self, "tk_getSaveFile", master), kw)

	def go(self, dir_or_file=os.curdir, pattern="*", default="", key=None):
	    return self.show(initialdir=dir_or_file,
			     defaultextension=pattern,
			     filetypes=((pattern,pattern),
					('Any File','*')),
			     initialfile=default)

##    OpenFile = OpenWrapper
##    SaveFile = SaveWrapper
