"""Multifile selection dialog class"""

from FileDialog import *
import string

class LoadFilesDialog(FileDialog):
     """File selection dialog which checks that the file exists."""
     title = "Load File Selection Dialog"

     def __init__(self, master, title=None):
	  FileDialog.__init__(self, master, title)

	  self.files.config(selectmode='extended', exportselection=1)
	  self.files.unbind('<ButtonRelease-1>')
	  self.files.unbind('<Double-ButtonRelease-1>')

	  self.selection.forget()

     def ok_command(self):
	  if self.get_selection()[:-1] != self.get_filter()[0]:
	       files = self.get_selection()
	       files = os.popen('ls %s'%files)
	       files = files.readlines()
	       for index in range(0,len(files)): #need to eliminate the \n
		    files[index] = files[index][:-1]
	  else:
	       files=[]
	       for item in self.files.curselection():
		   head = self.get_filter()[0]
		   tail = self.files.get(string.atoi(item))
		   file = os.path.join(head, tail)
		   files.append(file)
	  
	  if len(files) == 0:
	       self.master.bell()
	  else:
	       self.quit(files)

if __name__ == "__main__":
    app = Tk()
    app.withdraw()

    fd = LoadFilesDialog(app)

    filelist = fd.go('.','*.py')

    for filename in filelist:
	print filename
