#!/usr/bin/env python

import os, sys, string, regsub, ptInterpreter

_author_username = 'zack'
_destination = '/home/zack/programs/python/ptui'

def makeDistribution(destination):
     distribution = ['CommandPacket.py',
		     'defaults.py',
		     'DialogManager.py',
		     'FontText.py',
		     'Help-Bindings.txt',
		     'Help-Tutorial.txt',
		     'lifo.tcl',
		     'License.py',
		     'makeDistribution.py',
		     'MultiFileDialog.py',
		     'new.tcl',
		     'ptBuffer.py',
		     'ptInputText.py',
		     'ptInterpreter.py',
		     'ptInterpTrace.py',
		     'ptMegaWidgets.py',
		     'ptModular.py',
		     'ptObjectViewer.py',
		     'ptui',
		     'README',
		     'textundo.tcl'
		     ]

     if os.path.isdir(destination):
	  distrib_name = string.lower(ptInterpreter.Interpreter.Name) + \
			 '-' + ptInterpreter.Interpreter.Version
	  distrib_dir = os.path.join(destination,distrib_name)

	  os.mkdir(distrib_dir,0755)
	  files = ''
	  for file in distribution:
	       loc = filter(lambda d,f=file: os.path.exists(os.path.join(d,f))
			    ,sys.path)
	       files = files + ' ' + os.path.join(loc[0],file)

	  os.system('cp %s %s' % (files,distrib_dir))

	  os.chdir(distrib_dir)
	  lic = open('License.py')
	  data = lic.read()
	  lic.close()

	  data = regsub.sub('@@AUTHOR@@',ptInterpreter.Interpreter.Author,data)
	  data = regsub.sub('@@USER@@',_author_username,data)

	  os.chmod('License.py',0644)
	  lic = open('License.py','w')
	  lic.write(data)
	  lic.close()
	  os.chmod('License.py',0444)
	  
	  os.chdir(destination)
	  os.system('tar cvf %s.tar %s' % (distrib_name,distrib_name))
	  os.system('gzip %s.tar' % distrib_name)

makeDistribution(_destination)
