import sys,traceback,string,os

class TraceBackInfo:    
    def __init__(self,tb):
	co = tb.tb_frame.f_code

	self.filename = co.co_filename
	self.lineno = tb.tb_lineno
	self.name = co.co_name

    def __str__(self):
	file = 'File "%s"' % self.filename
	line = 'line %d' % self.lineno
	name = 'in %s' % self.name

	if self.filename == '<PTUI>':
	    file = 'In the current buffer'

	return string.joinfields([file,line,name],', ') + '\n'

    def isBuffer(self):
	return self.filename == '<PTUI>'


class InternalsWeeder:

    files = ['BasicWindow.py',
	     'CommandPacket.py',
	     'FileDialog.py',
	     'LabeledEntry.py',
	     'ScrolledText.py',
	     'InterpTrace.py',
	     'Interpreter.py',
	     'ObjectViewer.py',
	     'ptui']
    
    def __call__(self,tb_info):
	return not(os.path.split(tb_info.filename)[1] in self.files)


def createStackInfo(tb):
    info = []

    while tb:
	info.append(TraceBackInfo(tb))
	tb = tb.tb_next

    weeder = InternalsWeeder()

    return filter(weeder,info)


def printTraceBack(tb):
    info = createStackInfo(tb)

    lineno = None

    for item in info:
	sys.stderr.write(item)

	if item.isBuffer(): lineno = item.lineno

    traceback.print_exception(sys.exc_type,sys.exc_value,None)
    
    return lineno

